import os
import sqlite3
#import psycopg2 
from sqlite3 import Error
import csv
import math
from datetime import datetime
from datetime import timedelta

cwd = os.getcwd()

db_file = cwd+"/odpady_nova.db"
print(db_file)
def create_connection(db_file):
    """ create a database connection to the SQLite database
        specified by the db_file
    :param db_file: database file
    :return: Connection object or None
    """
    conn = None
    try:
        conn = sqlite3.connect(db_file)
    except Error as e:
        print(e)

    return conn

# priradi typ odpadu k ID collection
def define_trash_type(con):   
    cur = con.cursor()
    cur.execute("SELECT ID_COLLECTION FROM Collection_summary")
    collections = cur.fetchall()
    for collection in collections:
        cur.execute("SELECT PLA_ID_CONTAINER FROM Containers_ServingTime where ID_COLLECTION = '" + str(collection[0]) + "'")
        containers = cur.fetchall()
        if (len(containers)):
            id_container = containers[0][0]
            cur.execute("SELECT TrashType FROM PLAN1_FrequencyOfCollection where ID_CONTAINER = '" + str(id_container) + "'")
            trash_type = cur.fetchall()[0]
            cur.execute("UPDATE Collection_summary SET trash_type = '" + str(trash_type[0]) + "' where ID_COLLECTION = '" + str(collection[0]) + "'")
        else:
            print("No data for this collection")
    con.commit()
    cur.close()

# spocita ujetou vzdalenost pro dane vozidlo a datum
def define_distance(con, vehicle, date):
    cur = con.cursor()
    # identifikace id collection
    cur.execute("SELECT ID_COLLECTION FROM data where ID_Vehicle = '" + str(vehicle) + "' and Den = '" + str(date) + "'")
    zaznam = cur.fetchall()
    if len(zaznam):
        i = 0
        ID_COLLECTION = 0
        defined = False
        while (not defined and i<len(zaznam)):
            if zaznam[i][0] != "(NULL)":
                ID_COLLECTION = int(zaznam[i][0])
                defined = True
            i += 1
        if (ID_COLLECTION>0):
            # vypocet ujete vzdalenosti
            cur.execute("SELECT sum(MetersMoved) FROM data where ID_VEHICLE = '" + str(vehicle) + "' and Den = '" + str(date) + "'")
            meters = cur.fetchall()[0]
            cur.execute("UPDATE Collection_summary SET distance = '" + str(meters[0]) + "' where ID_COLLECTION = '" + str(ID_COLLECTION) + "'")
        con.commit()
        cur.close()

def distanceALL(con):
    cur = con.cursor()
    cur.execute("Select ID_Vehicle,Den from Collection_summary")
    records = cur.fetchall()
    for rec in records:
        define_distance(con, rec[0], rec[1])

def update_weight(con):
    cur = con.cursor()
    # identifikace id collection
    cur.execute("SELECT distinct(ID_COLLECTION) FROM WeightingProtocols")
    collections = cur.fetchall()
    if len(collections):
        for collection in collections:
            ID_COLLECTION = int(collection[0])
            cur.execute("SELECT max(TrashWeightInKg) FROM WeightingProtocols where ID_COLLECTION = '" + str(ID_COLLECTION) + "'")
            maxWeight = cur.fetchone()[0]
            cur.execute("UPDATE Collection_summary SET maxWeight = '" + str(maxWeight) + "' where ID_COLLECTION = '" + str(ID_COLLECTION) + "'")
    con.commit()
    cur.close()

def ALL_speed(con):
    cur = con.cursor()
    cur.execute("Select ID_Vehicle, Den, ID_COLLECTION from Collection_summary where ID_vehicle is not NULL")
    rows = cur.fetchall()
    counter = 0
    #for row in rows:
    for i in range(len(rows)):
        index = i
        calculate_speed(cur, rows[index][2], rows[index][0], rows[index][1])
        print(index)
    con.commit()
    cur.close()

def moveVehicles(con):
    cur = con.cursor()
    cur.execute("select ID_COLLECTION FROM Collection_summary")
    collections = cur.fetchall()
    for collection in collections:
        cur.execute("update Collection_summary set ID_VEHICLE = (select ID_VEHICLE from CollectionVehicles where ID_COLLECTION = '" + str(collection[0]) + "') where ID_COLLECTION = '"+ str(collection[0]) + "'")
    con.commit()


def calculate_speed(cur,collection,vehicle,date):
    
    # odhad doby vysypu
    unload_time = 900

    # vypocet ujete vzdalenosti
    cur.execute("SELECT sum(MetersMoved) FROM data where ID_VEHICLE = '" + str(vehicle) + "' and Den = '" + str(date) + "'")
    meters = cur.fetchall()[0][0]
    if (meters != None):
            
        # vypocet poctu vysypu a expertni odhad casu
        cur.execute("SELECT ID_COLLECTION FROM weightingProtocols where ID_VEHICLE = '"+str(collection) + "'")
        id_weight = cur.fetchall()
        unload_counter = len(id_weight)

        # vypocet delky celeho svozu
        cur.execute("SELECT StartedParkingRealTime, FinishedParkingRealTime FROM Collection_summary where ID_COLLECTION = '" + str(collection) + "'")
        times = cur.fetchall()
        for dtstr in times:
            start = str(dtstr[0])
            end = str(dtstr[1])
            duration = timedelta(seconds=0)
            if (end != "(NULL)" and start != "(NULL)"):
                dtobj_start = datetime.strptime(start, "%d.%m.%Y %H:%M")
                dtobj_end = datetime.strptime(end, "%d.%m.%Y %H:%M")
                duration = dtobj_end - dtobj_start
        if (duration.seconds != 0):
            # cas na obed pokud jezdi dele jak 4 hod 
            if (duration.seconds > 14400):
                lunch = 1800
            else:
                lunch = 0
            # vypocet celkove doby vysypu kontejneru
            cur.execute("select distinct(ID_COLLECTION_PLACE_ORIGINAL), Started, Finished From Containers_ServingTime where ID_COLLECTION= "+str(collection)+" AND Finished is not NULL")
            times = cur.fetchall()
            cas = 0
            for dtstr in times:
                dt_st = str(dtstr[1])
                dt_en = str(dtstr[2])
                if (dt_st != "(NULL)" and dt_en != "(NULL)"):
                    dtobj_st = datetime.strptime(dt_st, "%Y-%m-%d %H:%M:%S")
                    dtobjdt_en = datetime.strptime(dt_en, "%Y-%m-%d %H:%M:%S")
                    rozdil = dtobjdt_en-dtobj_st
                    cas += rozdil.seconds  
            if (cas != 0):      
                DUR_MOVE = (duration.seconds - cas - lunch - unload_counter * unload_time) 

                avg_speed = 3.6 * (meters/DUR_MOVE)
                vkladam_speed(con, collection, avg_speed)
            else:
                vkladam_speed(con, collection, "No containers")

        else:
            vkladam_speed(con, collection, "No start or end time")
    else:
        vkladam_speed(con, collection, "No distance")


def vkladam_speed(con, ID_COLLECTION, speed):
    try:
        cur = con.cursor()
        #sql_query = "INSERT INTO Average_speed (ID_COLLECTION, estim_speed) VALUES " + "(" + str(ID_COLLECTION) + "," + str(speed) + ")"
        sql_query = "update Collection_summary set avgSpeed = '" + str(speed) + "' where ID_COLLECTION = '"  + str(ID_COLLECTION) + "'" 
        count = cur.execute(sql_query)
        print("Vkladam zaznam:", ID_COLLECTION)
        con.commit()
        #cur.close()
    except sqlite3.Error as error:
        print("Failed to insert data into sqlite table", error)

def vkladam_trash_type(con, ID_COLLECTION, trash_type):
    try:
        cur = con.cursor()
        sql_query = "update Collection_summary set trash_type = '" + str(trash_type) + "' where ID_COLLECTION = '"  + str(ID_COLLECTION) + "'" 
        count = cur.execute(sql_query)
        print("Vkladam zaznam:", ID_COLLECTION)
        con.commit()
        #cur.close()
    except sqlite3.Error as error:
        print("Failed to insert data into sqlite table", error)        


con = create_connection(db_file)
#define_trash_type(con)
#update_weight(con)
#distanceALL(con)
#calculate_speed(con.cursor(), 9, '17.02.2020')
#calculate_speed(con.cursor(), 53618, 3, '08.05.2020')
ALL_speed(con)