import os
import sqlite3
from sqlite3 import Error
import csv
import math
from datetime import datetime

cwd = os.getcwd()

db_file = cwd+"/odpady_nova.db"
print(db_file)
def create_connection(db_file):
    """ create a database connection to the SQLite database
        specified by the db_file
    :param db_file: database file
    :return: Connection object or None
    """
    conn = None
    try:
        conn = sqlite3.connect(db_file)
    except Error as e:
        print(e)

    return conn

def trash_weight(con):
    cur = con.cursor()
    #sběry z vazicich listku
    cur.execute("SELECT distinct(ID_COLLECTION) FROM WeightingProtocols")
    rows = cur.fetchall()
    for row in rows:
        trash_type = ""
        
        #ID_containeru, objem, pocet 
        ID_COLLECTION = row[0]
        cur.execute("select PLA_ID_CONTAINER, VolumeInLiters, Count From Containers_ServingTime where ID_COLLECTION ="+str(ID_COLLECTION)+" AND Started is NOT NULL")            
        containers = cur.fetchall()
        litersSum = 0
        countTotal = 0
        count120 = count240 = count360 = count660 = count1100 = count1800 = count2500 = count3000 = count5000 = 0
        for cont in containers:
            volume = cont[1] 
            count = cont[2]
            litersSum += volume * count
            countTotal += count

            if (volume == 120):
                count120 += count
            elif (volume == 240):
                count240 += count
            elif (volume == 360):
                count360 += count
            elif (volume == 660):
                count660 += count
            elif (volume == 1100):
                count1100 += count
            elif (volume == 1800):
                count1800 += count
            elif (volume == 2500):
                count2500 += count
            elif (volume == 3000):
                count3000 += count
            elif (volume == 5000):
                count5000 += count

            # identifikace typu odpadu pro daný ID_COLLECTION
            if (trash_type == ""):
                cur.execute("select TrashType from PLAN1_FrequencyOfCollection where ID_CONTAINER =" + str(cont[0]))
                cont_plan = cur.fetchall()
                if (cont_plan != []):
                    trash_type = cont_plan[0][0]
        
        # zjisteni dne svozu odpadu
        cur.execute("select CollectionDate from Collection_summary where ID_COLLECTION ="+str(ID_COLLECTION))
        date = cur.fetchall()
        dt = str(date[0][0])
        dtobj = datetime.strptime(dt,"%d.%m.%Y %H:%M")
        weekDay = dtobj.weekday()
        
        # vaha odpadu (ID_COLLECTION)
        cur.execute("select TrashWeightInKg from WeightingProtocols where ID_COLLECTION ="+str(ID_COLLECTION))
        kgs = cur.fetchall()
        kg_per_collection = 0
        for i in range(len(kgs)): 
            kg_per_collection += kgs[i][0]
        if (litersSum != 0):
            coeficient_kg_L = kg_per_collection / litersSum
            vkladam_coeficient(con, ID_COLLECTION, trash_type, litersSum, kg_per_collection, coeficient_kg_L, countTotal, weekDay, count120, count240, count360, count660, count1100, count1800, count2500, count3000, count5000)
        else:
            print("no containers to sum up total volume")
        
        # vypis odhadu mnozstvi odpadu - rozvnomerne rozdeleni dle objemu
        # for i in range(len(containers)):
        #     id_cont = containers[i][0]
            
        #     # odhad hmotnosti odpadu v kontejneru "id_cont" v kg
        #     cur.execute("select distinct(VolumeInLiters) from Containers_ServingTime where PLA_ID_CONTAINER ="+str(id_cont))
        #     liters = cur.fetchall()
        #     cont_volume = liters[0][0]
        #     cont_weight_est = cont_volume * coeficient_kg_L * count

        #     print("trasa ="+str(ID_COLLECTION)+",popelnice = "+str(id_cont)+" popelnice litru =" + str(cont_volume) +", koeficient na trasu "+ str(coeficient_kg_L)+", druh popelnice =" + str(trash_type)+", pocet =" + str(count)+", den =" + str(weekDay))
            
        #     vkladam_data_trash(con, ID_COLLECTION, id_cont, cont_volume, trash_type, cont_weight_est, count, weekDay)


def vkladam_data_trash(con, ID_COLLECTION, id, conteiner_liters, trash_type, TrashTotal, count, weekDay):
    try:
        cur = con.cursor()
        sql_query = "insert into data_trash (ID_COLLECTION,PLA_ID_CONTAINER,VolumeInLiters,Container_trash,TrashTotal,Count,weekDay) values (" +str(ID_COLLECTION)+","+str(id)+","+str(conteiner_liters)+",'"+str(trash_type)+"',"+str(TrashTotal)+","+str(count)+","+str(weekDay)+")" 
        count = cur.execute(sql_query)
        print("Vkladam zaznam pro kontejner s ID: ", id)
        con.commit()
        #cur.close()
    except sqlite3.Error as error:
        print("Failed to insert data into sqlite table", error)

def vkladam_coeficient(con, ID_COLLECTION, trash_type, TotalVolume, TotalWeight, coeficient, count, weekDay, count120, count240, count360, count660, count1100, count1800, count2500, count3000, count5000):
    try:
        cur = con.cursor()
        sql_query = "insert into coef_data_KG_L (ID_COLLECTION,TRASH_TYPE,TotalWeight,TotalVolume,COEFFICIENT_KG_L,Count,weekDay,count120,count240,count360,count660,count1100,count1800,count2500,count3000,count5000) values (" +str(ID_COLLECTION)+",'"+ trash_type +"',"+str(TotalWeight)+","+str(TotalVolume)+","+str(coeficient)+","+str(count)+","+str(weekDay)+","+str(count120)+","+str(count240)+","+str(count360)+","+str(count660)+","+str(count1100)+","+str(count1800)+","+str(count2500)+","+str(count3000)+","+str(count5000)+")"
        cur.execute(sql_query) 
        print("Vkladam zaznam:", ID_COLLECTION)
        con.commit()
        #cur.close()
    except sqlite3.Error as error:
        print("Failed to insert data into sqlite table", error)
            
def cor_coef(con):
    cur = con.cursor()
    cur.execute("SELECT ID_COLLECTION, TotalVolume, TRASH_TYPE, COEFFICIENT_KG_L, count120, count240,count360, count660, count1100, count1800, count2500, count3000, count5000 FROM coef_data_KG_L")
    rows = cur.fetchall()
    for dat in rows:
        ID_COLLECTION = dat[0]
        TotalVolume = dat[1]
        TrashType = dat[2] 
        coef_kg_l = dat[3]
        count120 = dat[4]
        count240 = dat[5]
        count360 = dat[6]
        count660 = dat[7]
        count1100 = dat[8]
        count1800 = dat[9]
        count2500 = dat[10]
        count3000 = dat[11]
        count5000 = dat[12]

        # cor1 a cor2 jsou expertni odhady pomeru hustoty odpadu v malych a velkych kontejnerech
        if (TrashType == 'Glass'):
            cor1 = 1
            cor2 = 1
        elif (TrashType == 'Paper'):
            cor1 = 1
            cor2 = 1
        elif (TrashType == 'Plastics'): 
            cor1 = 1
            cor2 = 1
        elif (TrashType == 'BioWaste'):
            cor1 = 1
            cor2 = 1
        elif (TrashType == 'MixedWaste'):
            cor1 = 1
            cor2 = 1
        else:
            cor1 = 1
            cor2 = 1
        # vypocet jednotlivych clenu rovnice a vypocet redukcniho koeficientu
        x1 = cor1 * (count120 * 120 + count240 * 240 + count360 * 360 + count660 * 660)
        x2 = cor2 * (count1100 * 1100 + count1800 * 1800 + count2500 * 2500 + count3000 * 3000  + count5000 * 5000)
        x = TotalVolume / (x1 + x2)

        if (count120 != 0 or count240 != 0):
            cor1_new = coef_kg_l * cor1 * x 
        if (count1100 != 0 or count3000 != 0 or count5000): 
            cor2_new = coef_kg_l * cor2 * x

        print(cor1_new, cor2_new)

        # zjisteni dne svozu odpadu
        cur.execute("select CollectionDate from Collection_summary where ID_COLLECTION ="+str(ID_COLLECTION))
        date = cur.fetchall()
        dt = str(date[0][0])
        dtobj = datetime.strptime(dt,"%d.%m.%Y %H:%M")
        weekDay = dtobj.weekday()

        cur.execute("select PLA_ID_CONTAINER, VolumeInLiters, Count From Containers_ServingTime where ID_COLLECTION ="+str(ID_COLLECTION)+" AND Started is NOT NULL")  
        containers = cur.fetchall()
        for c in containers:
            ID = c[0]
            Volume = c[1]
            Count = c[2]  
            # vypocet hmotnosti pro velke kontejnery
            if (Volume ==  1100 or Volume ==  3000 or Volume == 5000 or Volume ==  1800 or Volume ==  2500):
                weight = Volume * cor2_new
            # vypocet hmotnosti pro male kontejnery
            else:
                weight = Volume * cor1_new
                
            vkladam_data_trash(con, ID_COLLECTION, ID, Volume, TrashType, weight, Count, weekDay)

# napocita nove koeficienty a odhadne hmotnost
con = create_connection(db_file)
#trash_weight(con)
cor_coef(con)