
import statistics
import numpy as np
# from avg_speed import create_connection
import os
import sqlite3
from sqlite3 import Error
from scipy.stats import t, shapiro

cwd = os.getcwd()

db_file = cwd+"/odpady_nova.db"
print(db_file)
def create_connection(db_file):
    """ create a database connection to the SQLite database
        specified by the db_file
    :param db_file: database file
    :return: Connection object or None
    """
    conn = None
    try:
        conn = sqlite3.connect(db_file)
    except Error as e:
        print(e)

    return conn


def test_mean_equal(con, values1, values2, alpha):
    cur = con.cursor()

    if (len(values1)>=3 and len(values2)>=3):
        W1, p1 = shapiro(values1) 
        W2, p2 = shapiro(values2)

        if (p1 >= alpha and p2 >= alpha):
            print ("Vysledek:", p1, p2, "nezamitame hypotezu o tom ze jsou oba soubory z normalniho rozdeleni")
        else:
            print ("Vysledek:", p1, p2, "nektery soubor neni z normalniho rozdeleni")
            return False, False

        #rozsah n souboru
        n1 = len(values1)
        n2 = len(values2)


        #stdev (výběrová směrodatná odchylka)
        s1 = statistics.stdev(values1)
        s2 = statistics.stdev(values2)

        #std average (prumer)
        sum_x1 = sum(values1)
        sum_x2 = sum(values2)        
        avgx1 = sum_x1 / n1
        avgx2 = sum_x2 / n2

        #mean (stredni hodnota)
        u1=0
        u2=0

        T2 = ((avgx1 - avgx2)-(u1 - u2)) / ((s1**2/n1 + s2**2/n2)**(1/2))

        v = ((s1*s1/n1 + s2*s2/n2)**(2)) / ( 1/(n1-1) * (s1**2/n1)**2 + 1/(n2-1) * (s2**2/n2)**2 )
        v = round(v)

        t_krit = t.ppf(1.0 - alpha, v)
        if (T2 <= t_krit and T2 >= -t_krit):
            print ("Vysledek:", T2, t_krit, "nezamitame")
            return True, True
        else: 
            print ("Vysledek:", T2, t_krit, "zamitame")
            return True, False
    else:
        print("maly rozsah souboru pro test normality")
    
    
    
def stat_hmotnost_weekday(con):
    cur = con.cursor()
    cur.execute("SELECT distinct(PLA_ID_CONTAINER) from data_trash")     #where PLA_ID_CONTAINER = '36614'"
    containers = cur.fetchall()
    for cont in containers:
        PLA_ID_CONTAINER = cont[0]
        cur.execute("SELECT distinct(weekDay) from data_trash where PLA_ID_CONTAINER='" + str(PLA_ID_CONTAINER) + "'")
        weekDays = cur.fetchall()
        
        for i in range(len(weekDays)):
            for j in range(i+1, len(weekDays)):
                # vyber hodnot soubor pro i-ty den z weekDays    
                cur.execute("SELECT TrashTotal from data_trash where PLA_ID_CONTAINER='" + str(PLA_ID_CONTAINER) + "' and weekDay = '" + str(weekDays[i][0])+"'")
                values1 = cur.fetchall()
                values1 = [value[0] for value in values1]
                # vyber hodnot soubor pro j-ty den z weekDays    
                cur.execute("SELECT TrashTotal from data_trash where PLA_ID_CONTAINER='" + str(PLA_ID_CONTAINER) + "' and weekDay = '" + str(weekDays[j][0])+"'")
                values2 = cur.fetchall()
                values2 = [value[0] for value in values2]

                vysledek = test_mean_equal(con, values1, values2, 0.05)


                if (vysledek == False, False):
                    celk_vysledek = (values1.count(values1), values2.count(values2))
                    print("Vysledek (nektery soubor neni z normalniho rozdeleni):", celk_vysledek)
                elif (vysledek == True, True):
                    celk_vysledek = (values1.count(values1), values2.count(values2))
                    print("Vysledek (nezamitame):", celk_vysledek)
                elif (vysledek == True, False):
                    celk_vysledek = (values1.count(values1), values2.count(values2))
                    print("Vysledek (zamitame rovnost strednich hodnot hmotnosti odpadu ve sbernych nadobach):", celk_vysledek)
        





#values1 = (17.255338528489,15.7508979710708,14.926582278481)
#values2 = (13.9269171384457,13.6710182767624,17.7240684793555,18.2191069574247,15.1001465559355,19.3219838614446,14.5668460483275,16.9322317301072)   


#con = create_connection(db_file)

#test_mean_equal(con, values1, values2, 0.05)

con = create_connection(db_file)

stat_hmotnost_weekday(con)